<template>
  <div class="flex flex-col h-full max-h-full">
    <Header />
    <DragAndDrop class="flex-1 hidden h-full lg:block">
      <button
        v-on:click.stop="demo"
        class="mt-4 text-black bg-gray-300 btn dark:bg-cgray-700 dark:text-cgray-200 hover:bg-gray-400 dark:hover:bg-cgray-600"
      >
        {{ $t('tryDemo') }}
      </button>
    </DragAndDrop>
    <div class="flex lg:hidden">
      <button
        v-on:click="$refs.file.click()"
        class="flex-1 mt-2 text-black bg-gray-300 lg:hidden btn dark:bg-cgray-700 dark:text-cgray-200 hover:bg-gray-400 dark:hover:bg-cgray-600"
      >
        {{ $t('import.chooseFileShort') }}
      </button>
      <input
        v-on:change="upload($event.target.files)"
        accept=".txt, .rptz"
        type="file"
        ref="file"
        class="hidden"
      />
      <button
        v-on:click="demo()"
        class="flex-1 mt-2 ml-2 text-black bg-gray-300 lg:hidden btn dark:bg-cgray-700 dark:text-cgray-200 hover:bg-gray-400 dark:hover:bg-cgray-600"
      >
        {{ $t('tryDemo') }}
      </button>
    </div>
  </div>
</template>

<script lang="ts">
  import { Component, Vue } from 'vue-property-decorator'
  import { State } from 'vuex-class'

  import { Factory } from '@/ts/factory'
  import { Project } from '@/ts/project'

  import Header from '@/components/Header.vue'

  import DragAndDrop from './components/DragAndDrop.vue'

  @Component({
    components: {
      DragAndDrop,
      Header,
    },
  })
  export default class C extends Vue {
    @State('factory')
    private factory!: Factory

    @State('project')
    private project!: Project

    private demo(): void {
      const getBrowserLocale = (languageCodeOnly = false) => {
        if (!navigator.language) {
          return undefined
        }

        const trimmedLocale = navigator.language.trim()

        return languageCodeOnly ? trimmedLocale.split(/-|_/)[0] : trimmedLocale
      }

      const locale = getBrowserLocale(true) === 'fr' ? 'FR' : 'EN'

      fetch(`https://v1.mapview.fr/Demo Heavydyn ${locale}.rptz`)
        .then((response) => response.blob())
        .then((blob) => {
          const file: File = new File([blob], 'demo.rptz')
          this.factory.import([file], this.project)
        })
    }

    private async upload(files: File[]) {
      this.factory.import(files, this.project)
    }
  }
</script>
